# https://docs.gitlab.com/ee/ci/yaml/README.html#configuration-parameters

stages:
  - init
  - pre-check
  - deploy-staging
  - deploy-qa

# New instance of service each time, these values wont exist in the next stage
read_secrets:
  extends: .vault
  stage: init
  image:
    name: vault
    entrypoint: [""]
  script:
    - vault kv get -field excited secret/hello && echo
    - printf '{{ (vault "secret/hello" "foo") }}' | dockcmd vault get-secrets --input-file -

download_build_image:
  extends: .docker-gitlab-registry
  stage: init
  script:
    - docker image pull $CI_REGISTRY/boxboat-gitlab-workshop/jenkins-to-gitlab/junit-jacoco-example


# https://gitlab.com/gitlab-org/gitlab-foss/-/issues/22745#note_408086865
check_with_timestamps:
  image: ubuntu
  stage: pre-check
  before_script:
    - apt-get update -y
    - apt-get install -y wget curl jq
    - ETS_VERSION=$(curl -s https://api.github.com/repos/zmwangx/ets/releases/latest | jq -r .tag_name | sed 's/^v//g')
    - wget -c https://github.com/zmwangx/ets/releases/download/v${ETS_VERSION}/ets_${ETS_VERSION}_linux_$(dpkg --print-architecture).tar.gz -O - | tar -xz -C /usr/local/bin
  script:
    - ets -s -f '[%T.%L]' echo something
    - ets -s -f '[%T.%L]' curl -sSlk google.com


deploy_staging:
  stage: deploy-staging
  timeout: 1m
  extends: .deploy
  resource_group: staging
  before_script:
    - echo "Deploy to staging server"
  environment:
    name: staging
    url: https://staging.example.com
  only:
    - master

deploy_qa:
  stage: deploy-qa
  extends: .deploy
  resource_group: qa
  before_script:
    - echo "Deploy to qa server"
  environment:
    name: production
    url: https://qa.example.com
  when: manual
  only:
    - master

include:
  - local: '/templates/vault-setup.yml'
  - local: '/templates/docker-setup.yml'
  - local: '/templates/deploy.yml'
